//+------------------------------------------------------------------+
//|                                                   PivotMagic.mq4 |
//|                                                      investor_me |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "investor_me"
#property link      "investor_me@gmail.com"

#include <WinUser32.mqh>

double    TakeProfit=50; // the minimum profit (in traded currency) that is needed to close a profitable trade (unlimited)
extern double    Lots=1;  // number of lots to trade (usually, 1 lot is $100k) (unlimited)
double    TrailingStop=55;   // the amount of the trailing stop needed to maximize profit (unlimited)
extern double    aggression_level=5; //(1-12) [low works for GBPUSD], high works for others.
int       wait_time_b4_SL=1000; // the time to wait after confirming a reversed trend (not in the trade's favor) before checking for stoploss
extern int   MAGIC=123456;
extern int       VolatilityToleranceLevel=3; // How tolerant should we be when assessing the volatility of the market? (from 1 to 10)
extern bool UsePredefinedParameters=true;

int              CleanUp_Weekday=5; // in case of weekly trades, this is the day that control of the possible drawdown will attempted

datetime         CleanUp_Date; // in case of weekly trades, this is the day that control of the possible drawdown will attempted

datetime StartTime, // time the EA started 
         last_action_time; // the last time any order was issued

bool     market_volatile, // is the market volatile, 
         trend_reversed, // is the trend reversed against us?
         midnight, noon, sixpm, sixam, // flags to help calculate the pivot values during the day
         trade_started,    // has the trade been started?
         trade_complete, // has the trade been completed (closed)?
         exit_ea, // is there an indication that the program must quit?
         sell_flag,  // trend suitable for a selling trade (signal above pivot)
         buy_flag, // trend suitable for a selling trade (signal below pivot)
         uhr[24],
         order_open;         
            
int      index, // the index counting the number of ticks processed so far
         time_pending, // the number of ticks that have been counted while an open trade is still pending
         ticket, // ticket number of last trade activity (sell or buy)
         total, // total number of active trades
         lostpips, // the number of pips that are currently losing
         macd_side, // the direction of the MACD indicator's graph value (1= above 0 & 2= below 0)
         current_zone, // the current zone where the signal is located
         last_zone, // the zone where the last signal was located 
         crossed, // has the signal crossed any of the pivot lines? If so, which one?
         last_crossed, // What was the last pivot line crossed?
         limit, // the translated value of aggression_level
         total_sig_count, // the total number of added signals at a specific time
         least_loss_cnt,
         cnt, pace, tp_cnt;

double   last_profit=0, // last known profit attained 
         total_sig=0, // total signal strength in the last 200 ticks
         average=0,  // average signal strength in the last 200 ticks
         last_pivot=0, // last known pivot value
         P,R1,R2,R3,M0,M1,M2,M3,M4,M5,S1,S2,S3, // pivot values
         buy_price, // the price that was found suitable for buying
         sell_price, // the price that was found suitable for selling
         least_loss,
         total_profit=0, tp_profit=0;
         
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  { int k;
//---- initialize all values as needed
   P=0;
   R1=0; R2=0; R3=0; 
   S1=0; S2=0; S3=0;
   M0=0; M1=0; M2=0; M3=0; M4=0; M5=0;

   index=0;
   total=0;
   current_zone=0; 
   last_zone=0;
   time_pending=0;   
   last_profit=0;
   total_sig=0;
   total_sig_count=0;
   average=0;
   last_pivot=0;
   cnt=0;
            
   market_volatile=false;
   trend_reversed=false;
   trade_started=false;
   trade_complete=false;
   exit_ea=false;
   order_open=false;

   for (k=0; k<24; k++) uhr[k]=false;

   VolatilityToleranceLevel=10*VolatilityToleranceLevel; // initialize volativity tolerance level

   TakeProfit=TakeProfit*(0.1/Lots); // initialize TakeProfit value according to Lots


//   confirm_trend_time=2*confirm_trend_time; // initialize TakeProfit value according to Lots

   if(Period() > 1440) // check if chart period is greater than 1 day
      {
         Print("Error - Chart period is greater than 1 day.");
         return(-1); // then exit
      }

/*   if(CurTime()>1151711999) // remind trader that this version is limited
      { 
         Alert ("This version is valid until June 30 2006");
         return(0);
      } */

   if(aggression_level>12 || aggression_level<0)   // confirm that the level of aggression is within limits
      {
         Print("aggression_level controls the risk/reward ratio and could be from 0 and 12.");
         return(0); // check TakeProfit
      }

   if (UsePredefinedParameters==true)
   { 
      if (Symbol()=="USDCHF") { aggression_level=5; VolatilityToleranceLevel=2; }
      if (Symbol()=="GBPUSD") { aggression_level=3; VolatilityToleranceLevel=4; }
      if (Symbol()=="EURUSD") { aggression_level=2; VolatilityToleranceLevel=3; }
      if (Symbol()=="USDJPY") { aggression_level=7; VolatilityToleranceLevel=3; }
      if (Symbol()=="AUDUSD") { aggression_level=6; VolatilityToleranceLevel=2; }
      if (Symbol()=="USDCAD") { aggression_level=6; VolatilityToleranceLevel=2; }
    }
   if (aggression_level>8) limit=1; else limit=9-aggression_level; // derive the value of the limit (to be used later) from agression_level

   return(0);
  }

//+------------------------------------------------------------------+
//| expert de-initialization function                                   |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//| MACD function derives the value of MACD with default settings    |
//+------------------------------------------------------------------+
int MACD_Direction ()
  {
   double MACDSignal;
   
   MACDSignal=iMA(NULL,PERIOD_H1,12,0,MODE_EMA,PRICE_CLOSE,0)-iMA(NULL,PERIOD_H1,26,0,MODE_EMA,PRICE_CLOSE,0);

   if(MACDSignal>=0) return (1); //value is 1 if signal is greater than 0
   else return (2);  //value is 2 if signal is less than 0
  }
//+------------------------------------------------------------------+
//| zone_no function finds the zone in which the input signal is in  |
//+------------------------------------------------------------------+
int zone_no (double s)
  {
   if (s>=P && s<M3) return (1);        // 1: Signal is between Pivot and M3 (above Pivot) 
   else if (s>=M3 && s<R1) return (2);  // 2: Signal is between M3 and R1 (above Pivot) 
   else if (s>=R1 && s<M4) return (3);  // 3: Signal is between R1 and M4 (above Pivot) 
   else if (s>=M4 && s<R2) return (4);  // 4: Signal is between M4 and R2 (above Pivot) 
   else if (s>=R2 && s<M5) return (5);  // 5: Signal is between R2 and M5 (above Pivot) 
   else if (s>=M5 && s<R3) return (6);  // 6: Signal is between M5 and R3 (above Pivot) 
   else if (s>=R3) return (7);          // 7: Signal is greater than R3   (above Pivot) 
   
   else if (s<P && s>=M2) return (-1);  // -1: Signal is between Pivot and M2 (below Pivot) 
   else if (s<M2 && s>=S1) return (-2); // -2: Signal is between M2 and S1 (below Pivot) 
   else if (s<S1 && s>=M1) return (-3); // -3: Signal is between S1 and M1 (below Pivot) 
   else if (s<M1 && s>=S2) return (-4); // -4: Signal is between M1 and S2 (below Pivot) 
   else if (s<S2 && s>=M0) return (-5); // -5: Signal is between S2 and M0 (below Pivot) 
   else if (s<M0 && s>=S3) return (-6); // -6: Signal is between M0 and S3 (below Pivot) 
   else if (s<S3) return (-7);          // -7: Signal is lower than S3 (below Pivot) 
  }
//+------------------------------------------------------------------------------------------+
//| PP_crossed function identifies signal value and direction when pivot points were crossed |
//+------------------------------------------------------------------------------------------+
int PP_crossed ()
  {   int k;
   //the below 4 conditional statements update pivot point data 4 times every day
   
   for (k=0; k<24; k++)
      {
         if (uhr[k]==false && TimeHour(Time[0])==k) { GetPivotPoints(); uhr[k]=true; } //hourly pp value
         else if (TimeHour(Time[0])!=k) { uhr[k]=false;}
      }
   current_zone=zone_no(Close[0]); //check the current zone

   if (last_zone==0) last_zone=current_zone;  //initialize last zone if it has not yet been initialized 

   if (current_zone!=last_zone) //earlier zone is not the same is current zone, so a pivot line was crossed!
      {  
       // buy when upward trend signalled //

         if (current_zone==7 && last_zone<=6)      { last_zone=current_zone; return (1); } //R3 crossed upwards     
         else if (current_zone==6 && last_zone<=5) { last_zone=current_zone; return (2); } //M5 crossed upwards (Aggression Level=12)
         else if (current_zone==5 && last_zone<=4) { last_zone=current_zone; return (3); } //R2 crossed upwards
         else if (current_zone==4 && last_zone<=3) { last_zone=current_zone; return (4); } //M4 crossed upwards
         else if (current_zone==3 && last_zone<=2) { last_zone=current_zone; return (5); } //R1 crossed upwards
         else if (current_zone==2 && last_zone<=1) { last_zone=current_zone; return (6); } //M3 crossed upwards

         else if (current_zone==1 && last_zone<=-1)  { last_zone=current_zone; return (7); } //Pivot crossed upwards (Agression Level=7)
         else if (current_zone==-1 && last_zone<=-2) { last_zone=current_zone; return (8); } //M2 crossed upwards
         else if (current_zone==-2 && last_zone<=-3) { last_zone=current_zone; return (9); } //S1 crossed upwards
         else if (current_zone==-3 && last_zone<=-4) { last_zone=current_zone; return (10); } //M1 crossed upwards
         else if (current_zone==-4 && last_zone<=-5) { last_zone=current_zone; return (11); } //S2 crossed upwards
         else if (current_zone==-5 && last_zone<=-6) { last_zone=current_zone; return (12); } //M0 crossed upwards
         else if (current_zone==-6 && last_zone<=-7) { last_zone=current_zone; return (13); } //S3 crossed upwards (Aggression Level=1)

      // sell when upper downward trend signalled //

         else if (current_zone==-7 && last_zone>=-6) { last_zone=current_zone; return (-1); } //S3 crossed downwards
         else if (current_zone==-6 && last_zone>=-5) { last_zone=current_zone; return (-2); } //M0 crossed downwards (Aggression Level=12)
         else if (current_zone==-5 && last_zone>=-4) { last_zone=current_zone; return (-3); } //S2 crossed downwards
         else if (current_zone==-4 && last_zone>=-3) { last_zone=current_zone; return (-4); } //M1 crossed downwards
         else if (current_zone==-3 && last_zone>=-2) { last_zone=current_zone; return (-5); } //S1 crossed downwards
         else if (current_zone==-2 && last_zone>=-1) { last_zone=current_zone; return (-6); } //M2 crossed downwards

         else if (current_zone==-1 && last_zone>=1){ last_zone=current_zone; return (-7); } //Pivot crossed downwards (Agression Level=7)
         else if (current_zone==1 && last_zone>=2) { last_zone=current_zone; return (-8); } //M3 crossed downwards
         else if (current_zone==2 && last_zone>=3) { last_zone=current_zone; return (-9); } //R1 crossed downwards
         else if (current_zone==3 && last_zone>=4) { last_zone=current_zone; return (-10); } //M4 crossed downwards
         else if (current_zone==4 && last_zone>=5) { last_zone=current_zone; return (-11); } //R2 crossed downwards
         else if (current_zone==5 && last_zone>=6) { last_zone=current_zone; return (-12); } //M5 crossed downwards
         else if (current_zone==6 && last_zone>=7) { last_zone=current_zone; return (-13); } //R3 crossed downwards (Aggression Level=1)
     }
   else return(0);
  }
//+--------------------------------------------------------------------------------------------------+
//| GetPivotPoints function updates all pivot point values based on available data from earlier date |
//+--------------------------------------------------------------------------------------------------+
void GetPivotPoints()
  { int k;
    double temp_P,sum=0,max=0,min=99999;
    
   for (k=1; k<=50; k++)
     { 
       if (Close[k]>max) max=Close[k];
       if (Close[k]<min) min=Close[k];
       sum=Close[k]+sum;
     }
   temp_P=sum/50;       
   R1 = (2*temp_P)-min;
   S1 = (2*temp_P)-max;
   R2 = temp_P+(max-min);
   S2 = temp_P-(max-min);
   R3 = (2*temp_P)+(max-(2*min));
   S3 = (2*temp_P)-((2*max)-min); 
   M5 = (R2+R3)/2;
   M4 = (R1+R2)/2;
	M3 = (temp_P+R1)/2;
	M2 = (temp_P+S1)/2;
   M1 = (S1+S2)/2;
	M0 = (S2+S3)/2;

   if (temp_P!=last_pivot) last_pivot=P; // last_pivot value has changed, and so have all other PP values, so save last_pivot value
   P=temp_P; // assign new pivot point value

   if (last_pivot==0) last_pivot=P; // initialize last pivot point value if not yet initalized
  }
//+--------------------------------------------------------------------------------+
//| ClosePending function closes the open order (mainly due to stoploss condition) |
//+--------------------------------------------------------------------------------+
void ClosePending()
 {
     if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())  // confirm that an order in the current traded pair is indeed valid
        {
          if(OrderType()==OP_BUY)
             {  
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);  // long position is open, so go ahead and close it
             }  
          else
             {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);  // short position is open, so go ahead and close it
             }  
        }
 }
//+-------------------------------------------------------------------------+
//| market_volatile function checks if the market is highly volatile or not |
//+-------------------------------------------------------------------------+
int market_volatile()
 {
   int no_trades=0,total_crosses=0,j, total_sig=0;

Print ("h_h1:",iHigh(NULL,PERIOD_H1,1)," l_h1:",iLow(NULL,PERIOD_H1,1)," h_h0:",iHigh(NULL,PERIOD_H1,0)," l_h0:",iLow(NULL,PERIOD_H1,0));

   for(j=200;j>0;j--) // check the number of non-trade bars and erratic signals
      { 
         if (Close[j]==Open[j]) no_trades++;  // calculate days
         if ((zone_no(Close[j])-zone_no(Close[j+1]))>1 || (zone_no(Close[j+2])-zone_no(Close[j]))>1) total_crosses++; // total number of erratic jumps 
         total_sig=Close[j]+total_sig;
      } 
        
   if (no_trades>20*VolatilityToleranceLevel || total_crosses>20*VolatilityToleranceLevel) 
      return (1);  // the market is volatile because more than 50% of the last bars were dojis (no trade occurred)

/*   if (iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,0)>0.001 && iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,0)>iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,5))
    return (1); */

   if (TimeDayOfWeek(Time[0])==0) return (1); // trade not supposed to be on a Sunday! 

   if (TimeDayOfWeek(Time[0])==TimeDayOfWeek(CleanUp_Date)) return (1); // do not trade on Clean Up Day! 
   
   // check to see if the successive pivot values have a difference of 50 pips or more! If so, this is not a regular market!

   if ((last_pivot>P && last_pivot-P>Point*VolatilityToleranceLevel) || (last_pivot<P && P-last_pivot>Point*VolatilityToleranceLevel)) return (1); 

   if ((buy_flag==true && Close[0]>iHigh(NULL,PERIOD_H4,1) && iHigh(NULL,PERIOD_H4,1)>0) 
      ||(sell_flag==true && Close[0]<iLow(NULL,PERIOD_H4,1) && iLow(NULL,PERIOD_H4,1>0)))  return (1);

   if ((iHigh(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,1)>(P*0.01)) 
      ||(iHigh(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,0)>(P*0.01))
      ||(iLow(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,0)>(P*0.01))
      ||(iHigh(NULL,PERIOD_H1,0)-iLow(NULL,PERIOD_H1,0)>(P*0.01)) && iLow(NULL,PERIOD_H1,1>0))  return (1);

Print ("h_h1:",iHigh(NULL,PERIOD_H1,1)," l_h1:",iLow(NULL,PERIOD_H1,1)," h_h0:",iHigh(NULL,PERIOD_H1,0)," l_h0:",iLow(NULL,PERIOD_H1,0));

/*   if (lostpips<0 && total_profit<=TakeProfit) return (1);
   Print ("Lost pips:",lostpips, " tp:",TakeProfit); */

   macd_side=MACD_Direction(); // Also we need to measure the MACD direction and see if this indicator supports our conclusion
   
   if ((macd_side==2 && sell_flag==1) || (macd_side==1 && buy_flag==1)) return (1);

   if (Time[0]-StartTime<10) return (1); // don't trade in the first 10 seconds (highly unstable)

   if (Time[0]-last_action_time<60) return (1); // wait for 1 minute before starting another trade
   
/* 

   if ((sell_flag==true && Close[0]<=(total_sig/200)+(10*VolatilityToleranceLevel*Point))||(buy_flag==true && Close[0]>=(total_sig/200)-(10*VolatilityToleranceLevel*Point)))  return (1); 
*/   
   return (0); // otherwise, market is relatively non-volatile (never a guarantee though!)
 }
//+-------------------------------------------------------------------------+
//| market_volatile function checks if the market is highly volatile or not |
//+-------------------------------------------------------------------------+
int news_effect()
 {
   int no_trades=0,total_crosses=0,j, total_sig=0;

   for(j=100;j>0;j--) // check the number of non-trade bars and erratic signals
      { 
         if (Close[j]==Open[j]) no_trades++;  // calculate days
         if ((zone_no(Close[j])-zone_no(Close[j+1]))>1 || (zone_no(Close[j+2])-zone_no(Close[j]))>1) total_crosses++; // total number of erratic jumps 
         total_sig=Close[j]+total_sig;
      } 
        
   if (no_trades>5*VolatilityToleranceLevel || total_crosses>5*VolatilityToleranceLevel) 
      return (1);  // the market is volatile because more than 50% of the last bars were dojis (no trade occurred)

/*   if (iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,0)>0.001 && iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,0)>iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,5))
    return (1); */

   // check to see if the successive pivot values have a difference of 50 pips or more! If so, this is not a regular market!

   if ((last_pivot>P && last_pivot-P>Point*VolatilityToleranceLevel) || (last_pivot<P && P-last_pivot>Point*VolatilityToleranceLevel)) return (1); 

   if ((buy_flag==true && Close[0]>iHigh(NULL,PERIOD_H4,1) && iHigh(NULL,PERIOD_H4,1)>0) 
      ||(sell_flag==true && Close[0]<iLow(NULL,PERIOD_H4,1) && iLow(NULL,PERIOD_H4,1>0)))  return (1);

   if ((iHigh(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,1)>(P*0.01)) 
      ||(iHigh(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,0)>(P*0.01))
      ||(iLow(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,0)>(P*0.01))
      ||(iHigh(NULL,PERIOD_H1,0)-iLow(NULL,PERIOD_H1,0)>(P*0.01)) && iLow(NULL,PERIOD_H1,1>0))  return (1);

Print ("h_h1:",iHigh(NULL,PERIOD_H1,1)," l_h1:",iLow(NULL,PERIOD_H1,1)," h_h0:",iHigh(NULL,PERIOD_H1,0)," l_h0:",iLow(NULL,PERIOD_H1,0));

/*   if (lostpips<0 && total_profit<=TakeProfit) return (1);
   Print ("Lost pips:",lostpips, " tp:",TakeProfit); */

   macd_side=MACD_Direction(); // Also we need to measure the MACD direction and see if this indicator supports our conclusion
   
   if ((macd_side==2 && sell_flag==1) || (macd_side==1 && buy_flag==1)) return (1);

   if (Time[0]-StartTime<10) return (1); // don't trade in the first 10 seconds (highly unstable)

   if (Time[0]-last_action_time<60) return (1); // wait for 1 minute before starting another trade
   
/* 

   if ((sell_flag==true && Close[0]<=(total_sig/200)+(10*VolatilityToleranceLevel*Point))||(buy_flag==true && Close[0]>=(total_sig/200)-(10*VolatilityToleranceLevel*Point)))  return (1); 
*/   
   return (0); // otherwise, market is relatively non-volatile (never a guarantee though!)
 }
//+-------------------------------------------------------------------------+
//| market_volatile function checks if the market is highly volatile or not |
//+-------------------------------------------------------------------------+
int minimize_damage(int countdown)
 {
   int no_trades=0,total_crosses=0,j, total_sig=0;

   for(j=100;j>0;j--) // check the number of non-trade bars and erratic signals
      { 
         if (Close[j]==Open[j]) no_trades++;  // calculate days
         if ((zone_no(Close[j])-zone_no(Close[j+1]))>1 || (zone_no(Close[j+2])-zone_no(Close[j]))>1) total_crosses++; // total number of erratic jumps 
         total_sig=Close[j]+total_sig;
      } 
        
   if (no_trades>5*VolatilityToleranceLevel || total_crosses>5*VolatilityToleranceLevel) 
      return (1);  // the market is volatile because more than 50% of the last bars were dojis (no trade occurred)

/*   if (iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,0)>0.001 && iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,0)>iStdDev(NULL,PERIOD_M1,50,MODE_EMA,0,PRICE_CLOSE,5))
    return (1); */

   // check to see if the successive pivot values have a difference of 50 pips or more! If so, this is not a regular market!

   if ((last_pivot>P && last_pivot-P>Point*VolatilityToleranceLevel) || (last_pivot<P && P-last_pivot>Point*VolatilityToleranceLevel)) return (1); 

   if ((buy_flag==true && Close[0]>iHigh(NULL,PERIOD_H4,1) && iHigh(NULL,PERIOD_H4,1)>0) 
      ||(sell_flag==true && Close[0]<iLow(NULL,PERIOD_H4,1) && iLow(NULL,PERIOD_H4,1>0)))  return (1);

   if ((iHigh(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,1)>(P*0.01)) 
      ||(iHigh(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,0)>(P*0.01))
      ||(iLow(NULL,PERIOD_H1,1)-iLow(NULL,PERIOD_H1,0)>(P*0.01))
      ||(iHigh(NULL,PERIOD_H1,0)-iLow(NULL,PERIOD_H1,0)>(P*0.01)) && iLow(NULL,PERIOD_H1,1>0))  return (1);

Print ("h_h1:",iHigh(NULL,PERIOD_H1,1)," l_h1:",iLow(NULL,PERIOD_H1,1)," h_h0:",iHigh(NULL,PERIOD_H1,0)," l_h0:",iLow(NULL,PERIOD_H1,0));

/*   if (lostpips<0 && total_profit<=TakeProfit) return (1);
   Print ("Lost pips:",lostpips, " tp:",TakeProfit); */

   macd_side=MACD_Direction(); // Also we need to measure the MACD direction and see if this indicator supports our conclusion
   
   if ((macd_side==2 && sell_flag==1) || (macd_side==1 && buy_flag==1)) return (1);

   if (Time[0]-StartTime<10) return (1); // don't trade in the first 10 seconds (highly unstable)

   if (Time[0]-last_action_time<60) return (1); // wait for 1 minute before starting another trade
   
/* 

   if ((sell_flag==true && Close[0]<=(total_sig/200)+(10*VolatilityToleranceLevel*Point))||(buy_flag==true && Close[0]>=(total_sig/200)-(10*VolatilityToleranceLevel*Point)))  return (1); 
*/   
   return (0); // otherwise, market is relatively non-volatile (never a guarantee though!)
 }
//+-------------------------------------------------------------------------+
//| after a successful trade, ask the trader if he/she wants to continue    |
//+-------------------------------------------------------------------------+
/*
void ask_trader()
{
   if (trade_started==true && trade_complete==false && OrdersTotal()==0) // if a trade opportunity appears, ask the trader if we need to proceed or not
     {
      if(ObjectCreate("text_object", OBJ_TEXT, 0, D'2004.02.20 12:30', 1.0045)==false)
         {  if (last_profit==0) { last_profit=TakeProfit; } // check the last profit value, if not initialize, put in the TakeProfit value
            int ret=MessageBox("A trade has just finished with a profit of"+last_profit+", Continue with auto-trading?", MB_YESNO|MB_ICONQUESTION);
            if(ret==IDNO)    // if the trader decides to exit the EA and stop trading after a successful trade, exit the EA
               { Print ("Terminating PivotMagic EA session"); exit_ea=true; return(0); }
         }
     }
} */
//+------------------------------+
//| The main start function      |
//+------------------------------+
void do_order(int type)
 {
   if (type==1)
      {
             ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"PM",MAGIC,0,White); // buy
             if(ticket>0)
                     { 
                        if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                           { Print("BUY order opened : ",OrderOpenPrice()); trade_started=true; } // buy order successful
                        pace=5; tp_profit=0; tp_cnt=0;
                     }
              else Print("Error opening SELL order : ",GetLastError()," sl,ask:",DoubleToStr(Bid-TakeProfit*Point*0.1,6));
              time_pending=0; // clear pending time variables
              buy_flag=false; // also clear buy flag
      }
  else if (type==2)
      {
             ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"PM",MAGIC,0,Red);
             if(ticket>0)
                     {
                       if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                         { Print("SELL order opened : ",OrderOpenPrice());  trade_started=true; }
                       pace=5; tp_profit=0; tp_cnt=0;
                     }
             else Print("Error opening SELL order : ",GetLastError()," sl,bid:",DoubleToStr(Bid-TakeProfit*Point*0.1,6));
             time_pending=0; // clear pending time variables
             sell_flag=false; // also clear sell flag
      }
 
 }
//+------------------------------+
//| The main start function      |
//+------------------------------+
int trailing_stop(int type)
 {
     pace++;
     if(TrailingStop>0 && type==1 && pace>5 && tp_cnt<5) // check for trailing stop value
        { 
         if(Bid-OrderOpenPrice()>Point*TrailingStop)  // the situation seems to be in our favor, just add a trailing stop here.
          { 
           if(OrderStopLoss()<Bid-Point*TrailingStop)
            {
             OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
             tp_profit=((Bid-Point*TrailingStop)-OrderOpenPrice())/Point; //save the total loss value for reference
             pace=0; tp_cnt++; return (1);
            }
          }
        }

     else if(TrailingStop>0 && type==2 && pace>5 && tp_cnt<5) // check for trailing stop value
        { 
         if((OrderOpenPrice()-Ask)>(Point*TrailingStop))  // the situation seems to be in our favor, just add a trailing stop here.
          { 
           if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
            {
             OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
             tp_profit=(OrderOpenPrice()-(Ask+Point*TrailingStop))/Point; //save the total loss value for reference
             pace=0; tp_cnt++; return (1); 
            }
          }
        }
   if (TrailingStop>0 && tp_cnt>=5) ClosePending();
 }

int start()
  {
   int count; // locally used variable for the loop

   if (exit_ea==true) { return (0); } // check to see if the whole EA needs to be terminated. If yes, then skip all start iterations and end EA

   //ask_trader();

   if(Bars<100) {  Print("bars less than 100"); return(0); } //Not enough bars on this chart to activate the EA functions

   index++; // start counting the times start() is called

   if (index==1) { GetPivotPoints(); StartTime=Time[0]; last_action_time=Time[0]; return (0); } // if the pivot value is not calculated, then get the start time and pivot points

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                     /*********************HARD CORE WORK STARTS HERE**********************************/
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////FIRST: START WITH ALREADY PENDING ORDERS

   crossed=PP_crossed(); // check the crossed pivot lines

   total=OrdersTotal(); // check the total active orders

   for(count=0;count<total;count++) // if there are active totals then proceed with some work
      {
         order_open=true;
//Print("0P:(",DoubleToStr(Close[0],5),") crossed:",crossed," l_c:",last_crossed," p:",P," s1:",S1," s2:",S2," r1:",R1," r2:",R2," bf:",buy_flag," sf:",sell_flag," lp:",lostpips, " avg:",average, " pending:", time_pending, " tr:",trend_reversed, " l_p:",last_pivot," total_profit:",total_profit+tp_profit*Lots/0.1);
         OrderSelect(count, SELECT_BY_POS, MODE_TRADES);
         if (total>0 && OrderSymbol()==Symbol()) time_pending++; else time_pending=0; // if the symbol is the current chart's pair, then add to pending count, else reset it.
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
            {  
               lostpips=OrderProfit();  // check the current status of profit so far
               if(OrderType()==OP_BUY) // a long position is open and pending for this pair
                  {  
                     // Now check here if the order has been pending for a period longer than the allowed waiting period before allowing dynamic loss
                     // and also make sure that the trend is not in our favor
                     // but if the spot price still allows us to exit without loss, then do exit.

                     trailing_stop(1);
                     if (Close[0]>=OrderOpenPrice()+TakeProfit*Point) // continue to collect profit
                        { 
                           return (0); 
                        } // initialize pending time and trend value & go to next tick

                     if (time_pending>(wait_time_b4_SL) && Close[0]>=OrderOpenPrice()+Point*5) 
                        { 
                           ClosePending(); 
                           time_pending=0; 
                           return (0);
                        } // initialize pending time and trend value & go to next tick

/*                     if (time_pending>wait_time_b4_SL && total_profit+lostpips<TakeProfit && total_profit!=0)
                        { 
                           ClosePending(); 
                           total_profit=TakeProfit;
                           time_pending=0; 
                           return (0);
                        } // initialize pending time and trend value & go to next tick
*/
                     if ((time_pending>wait_time_b4_SL && total_profit+lostpips<0 && total_profit!=0))
                        { 
                           ClosePending(); 
                           total_profit=0;
                           time_pending=0; 
                           return (0);
                        }  // Waiting time reached, too many pips lost, & trend is clearly reversed. So don't take any more chances, close the order!
                  }
                else // it's a short order that is open 
                  { 
                     // Now check here if the order has been pending for a period longer than the allowed waiting period before allowing dynamic loss
                     // and also make sure that the trend is not in our favor
                     // but if the spot price still allows us to exit without loss, then do exit.

                     trailing_stop(2);
                     if (Close[0]<=OrderOpenPrice()-TakeProfit*Point) // continue to collect profit
                        { 
                           return (0);
                        } // initialize pending time and trend value & go to next tick

                     if (time_pending>(wait_time_b4_SL) && Close[0]<=OrderOpenPrice()-Point*5) 
                        { 
                           ClosePending(); 
                           time_pending=0; 
                           return (0);
                        } // initialize pending time and trend value & go to next tick

/*                     if (time_pending>wait_time_b4_SL && total_profit+lostpips<TakeProfit && total_profit!=0)
                        { 
                           ClosePending(); 
                           total_profit=TakeProfit;
                           time_pending=0; 
                           return (0);
                        } // initialize pending time and trend value & go to next tick

*/
                     if (time_pending>wait_time_b4_SL && total_profit+lostpips<0 && total_profit!=0) 
                        { 
                           ClosePending(); 
                           total_profit=0;
                           time_pending=0; 
                           return (0);
                        } // initialize pending time and trend value & go to next tick
                     
                     // This time, check if the order has been pending for a period longer than the allowed waiting period before allowing dynamic loss
                     // and also make sure that the trend is not in our favor and if the spot price indicates that we are in loss exceeding StopLoss value.                        

//Print("0P_s:(",DoubleToStr(Close[0],5),") crossed:",crossed," l_c:",last_crossed," p:",P," s1:",S1," s2:",S2," r1:",R1," r2:",R2," bf:",buy_flag," sf:",sell_flag," lp:",lostpips, " avg:",average, " pending:", time_pending, " tr:",trend_reversed, " l_p:",last_pivot);
/*                     if (total_profit+lostpips<0)
                        { 
                                 ClosePending(); 
                                 time_pending=0; 
                                 return (0);
                        } */ // Waiting time reached, too many pips lost, & trend is clearly reversed. So don't take any more chances, close the order!
                   }
              last_action_time=Time[0]; 
             }
        return (0);
      }

//////SECOND: NOW PROCEED WITH NEW ORDERS

   if (order_open==true) { total_profit=(Lots*tp_profit)/0.1+total_profit; order_open=false; }   

   if (crossed>=(13-aggression_level))  // if the crossed pivot line matches aggression level, mark a BUY flag
         { buy_flag=true; sell_flag=false; buy_price=Close[0]; sell_price=0; }

   else if (crossed<=(13-aggression_level)*(-1))    // if the crossed pivot line matches aggression level, mark a SELL flag
         { sell_flag=true; buy_flag=false; sell_price=Close[0]; buy_price=0; }

//Print("0S:(",DoubleToStr(Close[0],5),") crossed:",crossed," l_c:",last_crossed," p:",DoubleToStr(P,5)," s1:",DoubleToStr(S1,5)," s2:",DoubleToStr(S2,5)," r1:",DoubleToStr(R1,5)," r2:",DoubleToStr(R2,5)," bf:",buy_flag," sf:",sell_flag," lp:",lostpips, " avg:",average, " pending:", time_pending, " tr:",trend_reversed, " l_p:",last_pivot);

   if (crossed!=0) { last_crossed=crossed; } // we're done with crossed value now, so store it in the last_crossed value

   if (crossed==0 && (sell_flag==true || buy_flag==true)) 
      {
         if (buy_flag==true && buy_price==0) { buy_price=Close[0]; }
         if (sell_flag==true && sell_price==0) { sell_price=Close[0]; } 

//Print("1S:(",DoubleToStr(Close[0],5),") crossed:",crossed," l_c:",last_crossed," p:",DoubleToStr(P,5)," s1:",DoubleToStr(S1,5)," s2:",DoubleToStr(S2,5)," r1:",DoubleToStr(R1,5)," r2:",DoubleToStr(R2,5)," bf:",buy_flag," sf:",sell_flag," lp:",lostpips, " avg:",average, " pending:", time_pending, " tr:",trend_reversed, " l_p:",last_pivot);

         if (Close[0]<=buy_price && buy_flag==true) { trend_reversed=true; buy_price=Close[0]; }
         else if (Close[0]>=buy_price && sell_flag==true) { trend_reversed=true; sell_price=Close[0]; }
         else trend_reversed=false;

         if (buy_flag==true && Close[0]<buy_price) 
            { 
               buy_price=Close[0]; 
            }
         else if (sell_flag==true  && Close[0]>sell_price) 
             {  
               sell_price=Close[0];
             }
      } // there is no cross now, but there was one recently, so just wait for a while

   if ((sell_flag==true || buy_flag==true) && trend_reversed==true)
     { // so now we waited enough for the trend, the flags are set, and the price is in our favor at this moment, so go ahead with the order proceedings
     
//Print("2S:(",DoubleToStr(Close[0],5),") crossed:",crossed," l_c:",last_crossed," p:",DoubleToStr(P,5)," s1:",DoubleToStr(S1,5)," s2:",DoubleToStr(S2,5)," r1:",DoubleToStr(R1,5)," r2:",DoubleToStr(R2,5)," bf:",buy_flag," sf:",sell_flag," lp:",lostpips, " avg:",average, " pending:", time_pending, " tr:",trend_reversed, " l_p:",last_pivot);
      if (cnt<10) { cnt++; return(0); }
      else cnt=0;

      if (market_volatile()==1) // but of course, if the market is volatile, forget it and initialize variables and start all over! 
         { 
            buy_price=0; sell_price=0; buy_flag=0; sell_flag=0; trend_reversed=false; return (0); 
         }

      if (buy_flag==true) do_order(1); //Let's go buy some currency
      if (sell_flag==true) do_order(2); //so now we know it is a good time to sell
      last_action_time=Time[0];
     }     
 }



//Print("2S:(",DoubleToStr(Close[0],5),") crossed:",crossed,/*" p:",P," s1:",S1," s2:",S2," r1:",R1," r2:",R2,*/ " lz:",last_zone," bf:",buy_flag," sf:",sell_flag," lp:",lostpips, "avg:",average, "mv:",market_volatile());

























                   
//+------------------------------------------------------------------+

/*
   if (trade_started==true && trade_complete==false && OrdersTotal()==0) // if a trade opportunity appears, ask the trader if we need to proceed or not
     {
      if(ObjectCreate("text_object", OBJ_TEXT, 0, D'2004.02.20 12:30', 1.0045)==false)
         {  if (last_profit==0) { last_profit=TakeProfit; } // check the last profit value, if not initialize, put in the TakeProfit value
            int ret=MessageBox("A trade has just finished with a profit of"+last_profit+", Continue with auto-trading?", MB_YESNO|MB_ICONQUESTION);
            if(ret==IDNO)    // if the trader decides to exit the EA and stop trading after a successful trade, exit the EA
               { Print ("Terminating PivotMagic EA session"); exit_ea=true; return(0); }
         }
     }
*/

